# coding: utf-8

"""
    VMware Aria Automation Pipelines APIs

    Aria Automation Pipelines is a continuous integration and continuous delivery (CICD) tool that you use to build Pipelines that model the software release process in your DevOps lifecycle. By creating Pipelines, you build the code infrastructure that delivers your software rapidly and continuously.  This page describes the RESTful APIs for Aria Automation Pipelines. The APIs facilitate CRUD operations on the various resources and entities used throughout Aria Automation Pipelines (Pipelines, Endpoints, Variables, etc.) and allow operations on them (executing a Pipeline, validating an Endpoint connection, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Aria Automation Pipelines entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/codestream/api/endpoints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/codestream/api/endpoints?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/codestream/api/endpoints?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /codestream/api/endpoints?$filter=startswith(name, 'ABC')     /codestream/api/endpoints?$filter=toupper(name) eq 'ABCD-JENKINS'     /codestream/api/endpoints?$filter=substringof(%27bc%27,tolower(name))     /codestream/api/endpoints?$filter=name eq 'ABCD' and project eq 'demo'   # noqa: E501

    OpenAPI spec version: 2019-10-17
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class EmailEventConfig1(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'body': 'str',
        'endpoint': 'str',
        'event': 'str',
        'stage': 'str',
        'subject': 'str',
        'task': 'str',
        'to': 'list[str]'
    }

    attribute_map = {
        'body': 'body',
        'endpoint': 'endpoint',
        'event': 'event',
        'stage': 'stage',
        'subject': 'subject',
        'task': 'task',
        'to': 'to'
    }

    def __init__(self, body=None, endpoint=None, event=None, stage=None, subject=None, task=None, to=None):  # noqa: E501
        """EmailEventConfig1 - a model defined in Swagger"""  # noqa: E501
        self._body = None
        self._endpoint = None
        self._event = None
        self._stage = None
        self._subject = None
        self._task = None
        self._to = None
        self.discriminator = None
        if body is not None:
            self.body = body
        if endpoint is not None:
            self.endpoint = endpoint
        if event is not None:
            self.event = event
        if stage is not None:
            self.stage = stage
        if subject is not None:
            self.subject = subject
        if task is not None:
            self.task = task
        if to is not None:
            self.to = to

    @property
    def body(self):
        """Gets the body of this EmailEventConfig1.  # noqa: E501

        Email Body.  # noqa: E501

        :return: The body of this EmailEventConfig1.  # noqa: E501
        :rtype: str
        """
        return self._body

    @body.setter
    def body(self, body):
        """Sets the body of this EmailEventConfig1.

        Email Body.  # noqa: E501

        :param body: The body of this EmailEventConfig1.  # noqa: E501
        :type: str
        """

        self._body = body

    @property
    def endpoint(self):
        """Gets the endpoint of this EmailEventConfig1.  # noqa: E501


        :return: The endpoint of this EmailEventConfig1.  # noqa: E501
        :rtype: str
        """
        return self._endpoint

    @endpoint.setter
    def endpoint(self, endpoint):
        """Sets the endpoint of this EmailEventConfig1.


        :param endpoint: The endpoint of this EmailEventConfig1.  # noqa: E501
        :type: str
        """

        self._endpoint = endpoint

    @property
    def event(self):
        """Gets the event of this EmailEventConfig1.  # noqa: E501


        :return: The event of this EmailEventConfig1.  # noqa: E501
        :rtype: str
        """
        return self._event

    @event.setter
    def event(self, event):
        """Sets the event of this EmailEventConfig1.


        :param event: The event of this EmailEventConfig1.  # noqa: E501
        :type: str
        """
        allowed_values = ["SUCCESS", "FAILURE", "WAITING", "CANCELED", "STARTED"]  # noqa: E501
        if event not in allowed_values:
            raise ValueError(
                "Invalid value for `event` ({0}), must be one of {1}"  # noqa: E501
                .format(event, allowed_values)
            )

        self._event = event

    @property
    def stage(self):
        """Gets the stage of this EmailEventConfig1.  # noqa: E501


        :return: The stage of this EmailEventConfig1.  # noqa: E501
        :rtype: str
        """
        return self._stage

    @stage.setter
    def stage(self, stage):
        """Sets the stage of this EmailEventConfig1.


        :param stage: The stage of this EmailEventConfig1.  # noqa: E501
        :type: str
        """

        self._stage = stage

    @property
    def subject(self):
        """Gets the subject of this EmailEventConfig1.  # noqa: E501

        Subject for the email notification.  # noqa: E501

        :return: The subject of this EmailEventConfig1.  # noqa: E501
        :rtype: str
        """
        return self._subject

    @subject.setter
    def subject(self, subject):
        """Sets the subject of this EmailEventConfig1.

        Subject for the email notification.  # noqa: E501

        :param subject: The subject of this EmailEventConfig1.  # noqa: E501
        :type: str
        """

        self._subject = subject

    @property
    def task(self):
        """Gets the task of this EmailEventConfig1.  # noqa: E501


        :return: The task of this EmailEventConfig1.  # noqa: E501
        :rtype: str
        """
        return self._task

    @task.setter
    def task(self, task):
        """Sets the task of this EmailEventConfig1.


        :param task: The task of this EmailEventConfig1.  # noqa: E501
        :type: str
        """

        self._task = task

    @property
    def to(self):
        """Gets the to of this EmailEventConfig1.  # noqa: E501

        List of Email IDs of the recipients.  # noqa: E501

        :return: The to of this EmailEventConfig1.  # noqa: E501
        :rtype: list[str]
        """
        return self._to

    @to.setter
    def to(self, to):
        """Sets the to of this EmailEventConfig1.

        List of Email IDs of the recipients.  # noqa: E501

        :param to: The to of this EmailEventConfig1.  # noqa: E501
        :type: list[str]
        """

        self._to = to

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EmailEventConfig1, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EmailEventConfig1):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
